=== extras/packaging/gnu-linux/rules/debian/control ===
Source: jami
Section: comm
Priority: optional
Maintainer: The Jami project <jami@gnu.org>
Build-Depends: debhelper (>= 9),
               autoconf,
               automake,
               libtool,
               autotools-dev,
# qt client
               libqt-jami,
               python3,
               libnm-dev,
               libnotify-dev,
               libqrencode-dev,
               libayatana-appindicator3-dev | libappindicator3-dev,
# daemon
               libdbus-1-dev,
               libsystemd-dev,
               libupnp-dev,
               libgnutls28-dev,
               libpulse-dev,
               libasound2-dev,
               libexpat1-dev,
               libpcre3-dev,
               libyaml-cpp-dev,
               libboost-dev,
               libxext-dev,
               libxfixes-dev,
               libspeex-dev,
               libspeexdsp-dev,
               uuid-dev,
               libavcodec-dev,
               libavutil-dev,
               libavformat-dev,
               libswscale-dev,
               libavdevice-dev,
               libopus-dev,
               libudev-dev,
               libgsm1-dev,
               libjsoncpp-dev,
               libnatpmp-dev,
               libva-dev,
               libcrypto++-dev,
               libvdpau-dev,
               libssl-dev,
               libargon2-dev | libargon2-0-dev,
# other
               nasm,
               yasm,
Standards-Version: 4.1.5
Homepage: https://jami.net
Vcs-Git: https://git.jami.net/savoirfairelinux/jami-client-qt.git
Vcs-Browser: https://git.jami.net/savoirfairelinux/jami-client-qt

# The jami-all package is used as the "one-click install" package
# offered on the Jami website.  The following relationships ensure
# that installing the jami-all package replaces version of the other
# individual Jami packages.  This is so that users can fix any
# installation problem on their side by simply reinstalling as per the
# website instructions.
#
Package: jami-all
Architecture: any
Depends: gnupg,
         ${shlibs:Depends},
         ${misc:Depends}
Replaces: jami,
          jami-libclient,
          jami-daemon,
          libqt-jami (>= 6.4.3),
Conflicts: jami,
           jami-libclient,
           jami-libclient-gnome,
           jami-daemon,
           jami-gnome,
           libqt-jami
Description: One-click install package for Jami
 This package only exists to provide an easy installation user experience.
 To install the default client, install the 'jami' package.

Package: jami
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         jami-daemon (=${binary:Version}),
         libqt-jami (>= 6.4.3)
Provides: jami-qt
Replaces: jami-all,
          jami-libclient (<= 20220516.0214.9b42ad3~dfsg1-1)
Breaks: jami-libclient (<= 20220516.0214.9b42ad3~dfsg1-1)
Conflicts: jami-all
Description: Secure and distributed voice, video and chat platform - desktop client
 Jami (jami.net) is a secure and distributed voice, video and chat communication
 platform that requires no centralized server and leaves the power of privacy
 in the hands of the user.
 .
 This package contains the jami-qt desktop client.

# Made into a transitional package on 2022-06-21, after libjamiclient
# was merged into src/libclient under jami-client-qt.git, to provide
# an upgrade path to existing users.  Feel free to remove this package
# later into the future, some time after 2023-06-21 perhaps.
Package: jami-libclient
Architecture: any
Description: transitional package for jami
 This is a transitional package. Jami libclient has been merged into
 the jami-qt client code-base, and this package can be safely removed.

Package: jami-daemon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Secure and distributed voice, video and chat platform - daemon
 Jami (jami.net) is a secure and distributed voice, video and chat communication
 platform that requires no centralized server and leaves the power of privacy
 in the hands of the user.
 .
 This package contains the Jami daemon: jamid.
